
  Agent de Gestion Urbaine (AGU)
==================================

L'AGU est un outil plutôt récent ajouté au client GTK+ de Freeciv
version 1.12.1. Il est conçu pour vous aider à gérer vos cités c'est à
dire déployer les travailleurs sur les cases environnantes disponibles
(ou bien en faire des scientifiques, des percepteurs ou des artistes)
pour obtenir le meilleur de la cité. Vous pouvez activer ou désactiver
l'AGU à tout moment pour n'importe quelle cité, mais il y a des
handicaps (expliqués plus loin) si vous avez des cités gérées et
d'autres non gérées par AGU proches les unes des autres. Dans tous les
cas vous avez besoin de la version serveur 1.12.1 ou suivantes ; l'AGU
ne fonctionne pas sur les versions 1.12.0 et précédentes.

Le coeur de AGU est un algorithme optimisé, qui essaye de déployer les
travailleurs d'une cité de telle manière que le but défini par
l'utilisateur soit atteint autant que possible. Vous savez
probablement qu'il y a déjà quelques optimisations, lorsque vous
ouvrez une cité, et cliquez sur la case centrale (symbole de la cité)
de la mini carte. Cette optimisation essaye de maximiser le taux de
science ; mais il ne se préoccupe pas des désordres civils.

Le nouvel Agent de Gestion Urbaine (CMA=City Management Agent) va plus
loin que cette ancienne forme d'optimisation. En premier lieu, il
assure sa tâche à chaque fois que quelque chose change dans la
cité. Si la cité grandit ou diminue, des troupes quittent ou arrivent,
des cases sont irriguées, ont une mine ou bien sont occupées par des
ennemis, l'AGU devient actif. En second lieu, il supporte toutes
sortes d'optimisations comme la production (boucliers), l'or, la
science, ou le luxe. En troisième lieu, il donne au joueur un contrôle
très fin sur ceci, avec la possibilité de poser des contraintes sur
n'importe quel rendement de la cité. Ceci inclut une contrainte de
célébration, qui rend très facile de faire grandir votre cité, même en
des temps difficiles. En quatrième lieu, et probablement est-ce la
faculté la plus intéressante en temps de guerre, il garde vos cités en
état de contentement prévenant ainsi les révoltes.

  Usage
=========

Vous pouvez régler l'AGU pour une cité en ouvrant la fenêtre de la
cité et cliquez sur l'onglet AGU. Sur le coté gauche, vous pouvez
sélectionner un pré-réglage dans la liste, sur le coté droit vous
pouvez régler des buts plus complexes en changeant les barres de
défilement (glisseurs). Vous pouvez sélectionner un pré-réglage
d'abord, et ensuite le modifier. Une fois créé un nouveau réglage,
vous pouvez lui définir un nom. Ce n'est pas nécessaire mais très
utile à l'usage dans la mesure où, si un nom est défini, vous pouvez
voir et même changer les réglages à partir du rapport des
cités. N'oubliez pas d'enregistrer la configuration (dans le menu
"jeu") lorsque vous avez créé de nouveaux pré-réglages.

Les glisseurs sont de deux sortes : les glisseurs les plus à droites
sont des facteurs, qui mesurent la valeur d'un rendement par rapport
aux autres (par exemple combien de production vaudra le coup en tenant
compte de l'ensemble des facteurs) Les glisseurs les plus à gauche
sont les contraintes : vous pouvez décider par exemple que la cité ne
perde pas de nourriture en réglant la contrainte de surplus à zéro,
vous pouvez permettre que la cité perde de l'argent en réglant la
contrainte de surplus de l'or à -3 et presser la cité de générer au
moins une production de 5 par tour en réglant le surplus de production
à 5. La contrainte la plus puissante, pourtant, est la contrainte de
Célébration qui fait célébrer dans la cité en une fois (ce qui
habituellement prend effet le tour suivant après l'avoir modifié).

Il est évident que l'AGU ne peut respecter toutes ces contraintes dans
tous les cas. Chaque fois que les contraintes ne peuvent être
atteintes l'AGU quitte son service pour cette cité et affiche un
message : "l'agent ne peut pas remplir les pré-requis pour Paris et
redonne le contrôle." Vous avez alors le choix de gérer la cité par
vous même (ce qui a des inconvénients, voir plus loin) ou d'ouvrir la
cité et de changer les exigences de surplus se sorte qu'elles puissent
être atteintes.

Lorsque vous avez fait un réglage pour une cité, vous devez cliquer
sur le bouton "Contrôles" pour activer l'AGU. Si ce bouton est en
grisé, l'AGU est déjà actif ou bien l'action est impossible. Dans ce
dernier cas vous pouvez voir des tirets à la place des nombres dans
les blocs de résultat. Si vous voulez délibérément désactiver l'AGU
cliquez sur le bouton "Libérer la ville".


  Usage avancé
==================

Nous n'avons pas encore beaucoup d'expérience sur l'utilisation de
l'AGU, mais quelques remarques basiques peuvent aider. Habituellement
le but de vos cités dépend de la phase du jeu dans laquelle vous êtes,
selon que vous voulez vous étendre largement, grossir rapidement,
rechercher des avancés technologiques ou faire la guerre. Vous pouvez
vouloir régler un haut facteur de recherche pour la science, ou bien
un haut facteur de production pour produire des unités. Le plus haut
facteur est 25, ce qui veut dire que, si le facteur de production est
réglé à 25 et les autres à 1, l'AGU préfère un rendement de 1
production à 25 Or (ou commerce). C'est vraiment beaucoup parce ce que
l'argent permet d'acheter des unités aussi. Ceci veut dire également
que l'AGU est indifférent au fait de produire de l'or, de la science,
du luxe ou de la nourriture ; mais lorsque vous faites la guerre vous
préférez habituellement de l'or ou du luxe.  Donc c'est probablement
une bonne idée de définir une deuxième (voire même une troisième)
préférence pour le rendement de la cité, par exemple un facteur de 5
pour l'or. Ceci donne encore la préférence à 1 production sur 5 or (et
1 or sur 5 nourriture ou n'importe quoi d'autre).

Les contraintes ne sont pas utiles dans tous les cas. Si vous voulez
un haut revenu, il est probablement préférable de régler un facteur or
à 25, plutôt que de régler un surplus minimal de 5 ou plus. Parce
qu'une grosse cité peut faire plus d'argent qu'une petite, vous
finiriez par régler des surplus différents pour chaque cité.

Cependant si le surplus de production d'une cité est en dessous de
zéro, elle ne peut plus supporter toutes ses unités. Vous perdrez des
unités supportées par la cité. Si le surplus de nourriture est
négatif, la cité sera en famine et éventuellement (lorsque le grenier
est vide) descendra d'une taille. Ceci peut être intentionnel, mais
attention au fait que si une cité supporte des colons vous les perdrez
avant que la cité ne soit réduite. Les contraintes peuvent aussi avoir
une fonction d'alarme.

Quelles contraintes peuvent être atteintes dépend largement des taux
globaux de sciences, taxes, et luxe. Par exemple, un surplus d'or >=0
est plus facile à atteindre avec un taux de taxe élevé plutôt que
l'inverse. Vous devez toujours penser à changer ces taux quand vous
allez changer les réglages de l'AGU pour la plupart de vos cités.

Conseil : Pour éviter de libérer accidentellement vos cités lorsque
vous changez les taux, il est mieux de le faire dans la boîte de
dialogue des taxes plutôt que dans l'affichage des taux sur la fenêtre
principale.


 Inconvénients (Handicaps)
==========================

L'AGU est un outil très puissant, qui peut non seulement vous libérer
de la micro gestion de vos cités mais vous donne aussi les meilleures
performances que vous n'avez jamais vues (enfin pour la plupart des
joueurs :).

Il existe certains inconvénients cependant. Une fois que vous activez
l'AGU, il se saisit de toutes les bonnes cases qu'il trouve. Aussi il
est très difficile parfois de gérer soi-même une cité située prés
d'une autre contrôlée par AGU.  Ceci est vrai pour la fenêtre d'une
cité et également pour l'interface des travailleurs de la carte
principale. Si vous voulez disposer de cités contrôlées par AGU et de
cités "manuelles", vous devriez probablement les placer sur des îles
différentes.

Il existe plusieurs cas où l'AGU ne peut remplir son objectif
temporairement par exemple, quand vous déplacez un bateau d'une cité à
une autre, ou quand un ennemi traverse votre pays. L'AGU rend le
contrôle dans ces cas, et vous devez le réactiver manuellement. Une
approche globale pour prévenir ceci peut être de régler le surplus
minimal aussi bas que possible (-20). Bien entendu vous devez être
attentif aux surplus de nourriture et production.

Alors que l'AGU fait un bon boulot pour une ville unique, aucune case
ne sera libérée pour le bien d'une autre cité. Aussi les cités
contrôlées par AGU sont calculées dans un ordre aléatoire ; le
résultat peut dépendre de celui-ci et changer quand un recalcul est
fait (lorsque le taux de taxes change par exemple). Par conséquent
aucune garantie n'est donnée que le résultat final soit toujours
optimal.


  Configurer le fichier
========================

Le client permet à l'utilisateur d'enregistrer et de charger des
paramètres prédéfinis pour les agents. Choisir "Enregistrer la
configuration" à partir du menu "Jeu" sauvegardera non seulement vos
options générales et les options des messages, mais sauvegardera aussi
tous les changement effectués dans les réglages d'AGU.

Le format pour le fichier d'options (normalement ~/.civclientrc) est
comme suit (dans le cas ou voudriez changer les réglages manuellement,
c'est à dire avec un éditeur de texte).

Après l'entête [cma], il y a un "number_of_presets" (nombre de
pré-réglages).  Sa valeur doit être fixée au nombre de pré-réglages
présents dans le fichier.  Si vous ajoutez ou enlevez un pré-réglage
manuellement, vous devez ajuster ce nombre.

Après cela, il y a un tableau qui contient les pré-réglages. Voici
l'entête :
 
preset={ "name","minsurp0","factor0","minsurp1","factor1","minsurp2",
"factor2","minsurp3","factor3","minsurp4","factor4","minsurp5",
"factor5","reqhappy","factortarget","happyfactor"

Donc l'ordre des pré-réglages devrait être comme ceci :

nom du pré-réglage, minimal surplus 0, facteur 0, ... , 
nécessite que la cité soit heureuse, la cible facteur de bonheur 
doit être [0,1], 

Actuellement il y a 6 surplus et facteurs. Ce sont :
0 = nourriture, 1 = production, 2 = commerce, 3 = or, 4 = luxe,
5 = science

Toujours actuellement, "factortarget" n'est pas modifiable depuis le
client, voir le source "client/agents/cma_core.h" pour plus
d'information.

Le tableau doit toujours se terminer par un '}'.

Voici 21 pré-réglages que vous pouvez utiliser si vous n'y arrivez pas
avec les vôtres :

"Max nourriture",0,10,0,1,0,1,0,1,0,1,0,1,0,0,1
"Max production",0,1,0,10,0,1,0,1,0,1,0,1,0,0,1
"Max commerce",0,1,0,1,0,10,0,1,0,1,0,1,0,0,1
"Max taxes",0,1,0,1,0,1,0,10,0,1,0,1,0,0,1
"Max luxe",0,1,0,1,0,1,0,1,0,10,0,1,0,0,1
"Max science",0,1,0,1,0,1,0,1,0,1,0,10,0,0,1
"+2 nourriture",2,1,0,1,0,1,0,1,0,1,0,1,0,0,1
"+2 production",0,1,2,1,0,1,0,1,0,1,0,1,0,0,1
"+2 commerce",0,1,0,1,2,1,0,1,0,1,0,1,0,0,1
"+2 or",0,1,0,1,0,1,2,1,0,1,0,1,0,0,1
"+2 luxe",0,1,0,1,0,1,0,1,2,1,0,1,0,0,1
"+2 science",0,1,0,1,0,1,0,1,0,1,2,1,0,0,1
"Max nourriture pas de limite pour l'or",0,10,0,1,0,1,-20,1,0,1,0,1,0,0,1
"Max production pas de limite pour l'or",0,1,0,10,0,1,-20,1,0,1,0,1,0,0,1
"Max commerce pas de limite pour l'or",0,1,0,1,0,10,-20,1,0,1,0,1,0,0,1
"Max or pas de limite pour l'or",0,1,0,1,0,1,-20,10,0,1,0,1,0,0,1
"Max luxe pas de limite pour l'or",0,1,0,1,0,1,-20,1,0,10,0,1,0,0,1
"Max science pas de limite pour l'or",0,1,0,1,0,1,-20,1,0,1,0,10,0,0,1
"Max nourriture+prod. pas de limite pour l'or",0,10,0,10,0,1,-20,1,0,1,0,1,0,0,1
"Max nourriture+prod.+commerce",0,10,0,10,0,10,0,1,0,1,0,1,0,0,1
"Max tout",0,1,0,1,0,1,0,1,0,1,0,1,0,0,1

En voici 6 de plus ajoutés après-coup :

"+1 nourriture, max prod. pas de limite pour l'or",1,1,0,10,0,1,-20,1,0,1,0,1,0,0,1
"+2 nourriture, max prod. pas de limite pour l'or",2,1,0,10,0,1,-20,1,0,1,0,1,0,0,1
"+3 nourriture, max prod. pas de limite pour l'or",3,1,0,10,0,1,-20,1,0,1,0,1,0,0,1
"+4 nourriture, max prod. pas de limite pour l'or",4,1,0,10,0,1,-20,1,0,1,0,1,0,0,1
"+5 nourriture, max prod. pas de limite pour l'or",5,1,0,10,0,1,-20,1,0,1,0,1,0,0,1
"+6 nourriture, max prod. pas de limite pour l'or",6,1,0,10,0,1,-20,1,0,1,0,1,0,0,1

Et encore d'autres avec des buts multiples :

"recherche à tout prix",0,1,0,5,-20,1,-20,1,-20,1,-20,25,0,0,1
"célébration et croissance",1,1,0,25,-20,1,-20,12,-20,1,-20,1,1,0,1
"croissance à tout prix",1,25,0,5,-20,1,-20,1,-20,1,-20,5,0,0,1
"recherche et de la production",0,1,0,8,0,1,-3,1,0,1,0,25,0,0,1
"production et un peu d'argent",0,1,0,25,0,1,-3,3,0,1,0,1,0,0,1
"beaucoup de production et de l'argent",0,1,0,25,0,1,0,9,0,1,0,1,0,0,1
"production et de la recherche",0,1,0,25,0,1,-2,1,0,1,0,8,0,0,1
"célébration et croissance en un coup",1,1,0,25,-20,1,-20,1,-20,1,-20,8,1,0,1


traduction sitro@nerim.net


Last updated: 9 Jan 2002
