=====================
Freeciv Version 2.0.0
=====================

Bienvenue à Freeciv !

Cette archive contient Freeciv, un clone libre de Civilization pour X,
principalement sous Unix. Il permet les parties multijoueurs locales ou
à travers un réseau, et inclut une IA qui donne du fil à retordre à la
plupart des joueurs.

Le but de Freeciv est d'avoir des règles compatibles avec Civilization
II [tm], publié par Sid Meier et Microprose [tm]. Quelques règles
diffèrent (lorsque nous avons jugé que c'était plus logique), et il y a
beaucoup de paramètres réglables pour permettre la personnalisation des
parties.

Freeciv a été implémenté totalement indépendamment de Civilization ;
vous n'avez pas besoin de posséder Civilization pour jouer à Freeciv.

Bien que les graphismes ne soient pas aussi soignés que ceux de
Civilization II, les règles sont très complètes et notre code réseau et
multijoueurs est excellent.


Site web :
==========

Le site web de Freeciv se trouve à cette adresse :

  http://www.freeciv.org/

Nous vous invitons à le visiter. Vous pourrez y trouver les dernières
nouvelles concernant Freeciv, dernières versions et patches, trouver 
des informations à propos des listes de diffusion et consulter le 
métaserveur Freeciv, qui répertorie des parties du monde entier.


Licence:
========

Freeciv est distribué sous la GNU GPL. En bref, vous pouvez copier ce
programme (y compris ses sources) librement. Tous les détails se
trouvent dans le fichier COPYING.


Compilation et installation :
=============================

Merci de lire attentivement le fichier INSTALL.fr pour savoir comment
compiler et installer Freeciv sur votre machine.


Commencer une partie:
=====================

Freeciv se compose en fait de deux programmes : un serveur et un
client. Lorsqu'une partie est en cours, il y a un programme serveur qui
tourne, et autant de programmes clients que de joueurs humains. Le
serveur, au contraire des clients, n'a pas besoin de X.

  NOTE :
  Les exemples suivants partent du principe que Freeciv a été installé
  sur votre système, et que le répertoire contenant les programmes
  "civclient" et "civserver" est dans votre PATH. Si Freeciv n'est pas
  installé, vous pouvez utiliser les programmes "civ" et "ser", qui se
  trouvent dans le répertoire racine de Freeciv. Ils s'utilisent
  exactement de la même façon que "civclient" et "civserver".


Jouer à Freeciv implique de lancer le serveur, puis le(s) client(s) et de
créer la ou les IA. Ensuite, vous devez lancer la partie depuis le
serveur. Voici les étapes :


Serveur :

  Pour lancer le serveur :

  |  % civserver

  Ou pour la liste des options en ligne de commande :

  |  % civserver --help

  Une fois que le serveur est lancé, une invite doit apparaître :
  |  Pour obtenir une aide sommaire, tapez 'help'.
  |  >
  
  [ si ce message n'est pas en Français, et que vous voulez absolument
  jouer dans notre langue, positionnez la variable d'environnement LANG
  à "fr". Pour plus de détails, consultez le fichier INSTALL.fr ]


  En tapant la commande 'help', vous pouvez donc voir ceci :
  |  > help
  |  Bienvenue - ceci est le texte d'aide introductif du serveur Freeciv.
  |
  |  Les commandes et les options sont deux concepts importants pour le 
  |  serveur.
  |  Les commandes, comme 'help', sont utilisées pour interagir avec le
  |  serveur. Certaines commandes prennent un ou plusieurs arguments, séparés
  |  par des espaces. Dans la plupart des cas, les commands et les arguments
  |  des commandes peuvent être abrégés. Les options sont des paramètres qui
  |  contrôlent le serveur.
  |
  |  Pour savoir comment obtenir plus d'informations sur les commandes et
  |  les options, utilisez 'help help'.
  |
  |  Pour l'impatient, les commandes principales pour commencer sont :
  |  show  - pour voir les options actuelles
  |  set   - pour régler des options
  |  start - pour lancer la partie une fois que les joueurs sont connectés
  |  save  - pour sauver la partie en cours
  |  quit  - pour quitter
  |  >

  Si vous le désirez, vous pouvez utiliser la commande 'set' pour régler
  certaines options de la partie. Vous pouvez obtenir une liste des
  options grâce à la commande 'show', et une description détaillée de
  chacune avec 'help <nom-de-l'option>'.

  Par exemple :
  | > help size
  |  Option : size  -  Taille de la carte (en milliers de cases)
  |  Description :
  |    Cette valeur est utilisée pour déterminer les dimensions de la carte
  |    size = 4 est une carte normale de 4000 cases (défaut)
  |    size = 20 est une carte énorme de 20000 cases
  | État : modifiable
  | Valeur : 4, Minimum : 1, Défaut : 4, Maximum : 29

  Et :
  |  > set size 8
 
  Ceci rendra la carte deux fois plus grande que celle par défaut.

Client :

  À présent, tous les joueurs humains devraient se connecter en lançant
  le client Freeciv :

  |  % civclient

  Ceci part du principe que le serveur tourne sur la même machine. 
  Sinon, vous pouvez le spécifier en ligne de commande à l'aide
  de l'option '--server' ou le saisir dans la première boîte de 
  dialogue lorsque le client est lancé.

  Par exemple, supposons que le serveur tourne sur une machine
  différente appelée 'neptune'. Dans ce cas, les joueurs rejoignent la
  partie avec une commande de ce style :

  |  % civclient --server neptune

  Si vous êtes le seul joueur humain, un seul client a besoin d'être
  lancé. Vous pouvez lancer le client "en tâche de fond" de la manière
  standard sous Unix en ajoutant un "&" à la suite de "civclient" :

  |  % civclient &

  Une autre option du client que vous devriez apprécier est '--tiles',
  qui peut être utilisée pour choisir des "tilesets" différents
  (c'est-à-dire des graphismes différents pour le terrain, les unités,
  etc). La distribution fournit deux tilesets principaux:
  - isotrident : un tileset similaire à celui de civ2 (par encore   
    supporté par le client Xaw)
  - trident : un tileset dans le style civ1 avec des case de 30x30.
    Le tileset trident a une variante nommée "trident_shields".

  Dans cette distribution, "trident" est le tileset par défaut pour les 
  clients GTK+, amiga et win32 tandis que le client Xaw utilise trident. 
  Les variantes "_shields" utilisent des drapeaux de la forme de 
  boucliers, plus petits. Essayez-les et décidez par vous-même. Pour 
  tester le tileset trident : lancez le client ainsi :

  |  % civclient --tiles trident

  D'autres tilesets sont disponibles sur le site ftp.


  Les clients peuvent être autorisés à utiliser des commandes du
  serveur. Pour les autoriser à n'utiliser que des commandes
  "d'information", tapez ce qui suit à l'invite du serveur :

  |  > cmdlevel info

  Les clients peuvent à présent utiliser '/help', '/list', '/show
  settlers', etc.


Joueurs IA :

  Il y a deux façons de créer des joueurs IA. La première est de régler
  le nombre total de joueurs (humains et IA) à l'aide de l'option
  'aifill' du serveur. Par exemple :

  |  > set aifill 7

  Après avoir utilisé la commande 'start' du serveur pour commencer la
  partie, tous les joueurs qui ne sont pas contrôlés par des humains
  seront des joueurs IA. Dans l'exemple ci-dessus, si 2 joueurs humains
  ont rejoint la partie, 5 joueurs IA seront créés.

  La deuxième façon est de créer explicitement une IA avec la commande
  'create' du serveur. Par exemple :

  |  > create TueurdHumains

  Ceci créera un joueur IA appelé TueurdHumains.

  Des nations sont assignées aux joueurs IA après que tous les joueurs
  humains aient choisi les leurs, mais vous pouvez choisir une nation
  particulière pour un joueur IA en utilisant le nom normal pour le chef
  de cette nation. Par exemple, pour jouer contre des Romains contrôlés
  par l'IA, utilisez la commande du serveur suivante :

  |  > create Caesar

  Note : ceci n'est qu'une préférence. Si aucun joueur humain ne choisit
  de jouer les Romains, alors cette IA les prendra.

Serveur :

  Une fois que tout le monde a rejoint la partie (utilisez la commande
  "list" pour savoir qui est là), lancez la partie avec la commande
  "start" :

  |  > start

Et la partie est lancée !


Annoncer la partie :
====================

Si vous ne voulez pas limiter la concurrence à vos amis ou aux joueurs
IA, visitez le métaserveur Freeciv :

  http://meta.freeciv.org/metaserver/

C'est une liste de serveurs Freeciv. Pour que votre propre serveur
s'y annonce lui-même, lancez civserver avec l'option '--meta', ou '-m'.

Remarques :

 1) Étant donné l'inclusion de nouvelles fonctionnalités, des versions
    différentes du client et du serveur sont souvent incompatibles. 
    La version 2.0.0 est incompatible avec les version 1.14.2 ou 
    antérieures.

 2) Si le bouton Métaserveur dans la boîte de dialogue de connexion ne
    fonctionne pas, vérifiez si votre fournisser d'accès utilise un
    proxy WWW et signalez-le au client à l'aide de la variable
    d'environnement $http_proxy. Ainsi, si le proxy est
    proxy.monfournisseur.com, sur le port 8888, positionnez $http_proxy
    à http://proxy.monfournisseur.com:8888/ avant de lancer le client.

 3) Parfois, il n'y a pas de partie sur le métaserveur. Ceci arrive. 
    Le nombre de joueurs varie en fonction de l'heure. Essayez de lancer
    une partie vous-même !


Jouer :
=======

La partie peut être sauvée à n'importe quel moment en utilisant la
commande 'save' du serveur :

  |  > save mapartie.sav

Si votre serveur est compilé avec le support de la compression et que
l'option 'compress' du serveur a une autre valeur que 0 (zéro), alors le
fichier peut être compressé et sauvé sous un nom comme
'mapartie.sav.gz'.

Le client Freeciv fonctionne pour une partie de Civilization en
multijoueurs de la façon qu'on peut espérer. C'est à dire que les
joueurs humains se déplacent tous en même temps, puis tous les joueurs
IA se déplacent lorsque tous les joueurs humains ont terminé leur
tour. Il y a une valeur de timeout pour les tours, qui est par défaut de
0 seconde (pas de timeout). L'administrateur du serveur peut modifier
cette valeur à n'importe quel moment grâce à la commande 'set'.

Jetez un oeil au système d'aide en ligne. Les trois boutons de la souris
sont utilisés, et documentés dans l'aide.

Les joueurs peuvent appuyer sur la touche 'Entrée' pour annoncer la fin
de leur tour, ou simplement cliquer sur le bouton 'Fin du tour'.

Utilisez la boîte de dialogue 'Joueurs' pour savoir qui a annoncé la fin
de son tour, et qui vous attendez ("Hé ! Tu t'es endormi ou quoi ?" ;-) ).

Utilisez la ligne de saisie en bas de la fenêtre pour envoyer des
messages aux autres joueurs.

Vous pouvez envoyer un message à un seul joueur (par exemple 'pascal') :

  |  pascal: enlève ce char *maintenant* !

Le serveur est suffisamment intelligent pour "compléter" les
noms. Ainsi, si vous avez tapez "pas:", il cherchera un nom de joueur
qui commence par 'pas'.

Vous pouvez un message à l'ensemble de vos alliés en le préfixant avec le 
charactère '.' (oui, c'est un point).

Vous pouvez exécuter des commandes du serveur depuis la ligne de saisie
du client en les préfixant de '/' :

  |  /list
  |  /set settlers 4
  |  /save mapartie.sav

L'administrateur du serveur vous laissera probablement uniquement lancer
des commandes "d'information". Ceci vient en partie de considérations
liées à la sécurité. Imaginez un joueur qui essaye :

  |  /save /etc/passwd

Bien sûr, le serveur ne devrait pas être lancé avec les privilèges du
super-utilisateur pour réduire ce genre de risques.

Si vous débutez et désirez avoir une idée de stratégies possibles,
consultez le "Freeciv playing HOWTO", dans le fichier HOWTOPLAY.fr.

Pour avoir beaucoup plus de renseignements à propos du client, du
serveur et des concepts et règles du jeu, consultez le manuel de Freeciv
disponible sur le site web :

  http://www.freeciv.org/index.php/Manual
 

Fin de la partie :
==================

Il y a trois façons de terminer une partie :

1) Il ne reste q'une seule nation.
2) L'année de fin est atteinte.
3) Un joueur construit et lance un vaisseau spatial qui atteint Alpha
   du Centaure le premier.

Un tableau des scores sera montré dans tous les cas. Truc :
l'administrateur du serveur peut changer l'année de fin pendant que la
partie est en cours en modifiant l'option 'end-year'. C'est utile
lorsque l'on connaît déjà le vainqueur et que l'on veut pas avoir à
supporter la phase ennuyeuse de "nettoyage".


Chargement des parties :
========================

Vous pouvez charger une partie sauvée en utilisant l'option '-f' du
serveur :

  |  % civserver -f notresauvegarde2001.sav

Ou, si le fichier de sauvegarde est compressé :

  |  % civserver -f notresauvegarde2001.sav.gz

À présent, les joueurs peuvent rejoindre la partie :

  |  % civclient -n Alexandre

Remarquez que l'on peut préciser le nom du joueur avec l'option '-n'. Il
est primordial que les joueurs utilisent le même nom que lorsque la
partie était en cours, s'ils veulent pouvoir la rejoindre.

La partie peut ensuite être redémarrée avec la commande 'start', comme
d'habitude.


Localisation :
==============

Freeciv supporte un certain nombre de langues.

Vous pouvez choisir quel langue vous souhaitez en précisant une
"locale". Chaque locale a un nom standard (par exemple, 'fr' pour
Français). Si vous avez installé Freeciv, vous pouvez choisir une locale
en positionnant la variable d'environnement LANG correctement, avant de
lancer civserver et civclient.

Par exemple, pour utiliser la localisation française :

  export LANG; LANG=fr   (avec un shell Bourne (sh)),
ou
  setenv LANG fr         (avec le shell C (csh)).

(Vous pouvez faire ceci dans votre .profile ou votre .login)


Journal :
=========

Le client et le serveur affichent des messages de log ("journal"). Il y
a cinq catégories de messages : "fatal", "erreur" (error), "normal",
"verbeux" (verbose) et "deboguage" (debug).

Par défaut, les messages fatals, d'erreur et normaux sont affichés sur
la sortie standard à l'endroit où le client et le serveur ont été
lancés. Vous pouvez rediriger les messages vers un fichier au lieu de
l'écran avec l'option en ligne de commande "--log fichier" (ou "-l
fichier").

Vous pouvez modifier le niveau des messages affichés avec "--debug
niveau" ou "-d niveau" (ou "-de level" pour le client Xaw, car "-d" est
ambigu : "-debug" et "-display"), où "niveau" vaut 0, 1, 2 ou 3. 0
correspond aux messages fatals uniquement ; 1 montre les messages fatals
et les messages d'erreur ; 2 les messages fatals, d'erreur et normaux
(défaut) ; et 3 montre tous les messages.

Si vous avez compilé Freeciv en définissant DEBUG (vous pouvez
facilement le faire en lançant ./configure avec --enable-debug), vous
pouvez avoir les messages de niveau "deboguage" en réglant le niveau à
4. De plus, il est possible de contrôler le niveau des messages de
déboguage (mais pas les autres) par fichier et par ligne. Pour ce faire,
utilisez "--debug 4:chaîne1:chaîne2" (autant de chaînes que vous voulez,
séparées par des virgules) et tous les noms de fichiers sources qui
contiennent ces sous-chaînes seront activés, tandis que tous les autres
seront supprimés. Pour contrôler les lignes, utilisez : "--debug
4:chaîne1,min,max" et, pour les fichiers qui correspondent à chaîne1,
seuls les messages de déboguage ayant entre min et max lignes seront
affichés. Un seul couple (min,max) peut être appliqué à chaque
fichier.

Exemple :

  |  % civserver -l mon.log -d 3

Ceci met tous les messages de log du serveur dans le fichier "mon.log",
y compris les messages de niveau verbeux.

Exemple:

  |  % civclient --debug 0

Ceci supprime tous les messages de log non fatals du client.

Exemple:

  |  % civserver -d 4:log:civserver,120,500:autoattack

Ceci active tous les messages pour le serveur, et les messages de
déboguage pour certains modules. Notez que "log" s'applique autant à
"gamelog.c" qu'à "log.c". Pour "civserver.c", les messages de déboguage
entre les lignes 120 et 500 seront affichés. Cet exemple ne fonctionne
que si le serveur à été compilé avec DEBUG.


Bogues :
========

Vous avez trouvé un bogue ? Prévenez-nous, afin que nous puissions le
corriger. Consultez le fichier BUGS pour avoir une liste des bogues
connus dans cette distribution, ainsi que des renseignements pour
signaler de nouveaux bogues.


Listes de diffusion :
=====================

Nous maintenons 8 listes de diffusion :

  freeciv          Discussions générales.
  freeciv-announce Annonces d'intérêt général.
		   C'est une liste en "lecture seule", avec des messages
		   peu fréquents. En d'autres termes, vous ne pouvez que
		   la lire, et pas y écrire. Les annonces qui y sont
		   envoyées le sont aussi sur freeciv.
  freeciv-i18n     Traduction de Freeciv.
                   Toutes les discussions à propos de la traduction du
                   code de Freeciv, de sa documentation et du site web en
                   d'autres langages que l'anglais.
  freeciv-dev      Développement de Freeciv.
  freeciv-data     Développement du répertoire "data".
		   Discussions sur les règles, les graphiques, etc.
  freeciv-java     Développement du client Freeciv en Java.
  freeciv-ai       Développement de l'IA de Freeciv.
  freeciv-cvs      Annonces de changements sur le CVS.
		   C'est une liste en "lecture seule", diffusant des
		   messages automatisés. En d'autres termes, vous ne
		   pouvez que la lire, et pas y écrire.

Toutes ces listes sont publiques et chacun est le bienvenu pour s'y
inscrire.


Pour s'inscrire (ou se désinscrire) à ces listes, procédez comme suit :

  1. Envoyez un e-mail à <listar@freeciv.org>.
  2. Laissez le sujet vide.
  3. Dans le corps de l'e-mail, mettez un des messages suivants :
      Pour vous inscrire :
        subscribe freeciv
        subscribe freeciv-announce
        subscribe freeciv-dev
        subscribe freeciv-data
        subscribe freeciv-java
        subscribe freeciv-cvs
      Pour vous désinscrire :
        unsubscribe freeciv
        unsubscribe freeciv-announce
        unsubscribe freeciv-dev
        unsubscribe freeciv-data
        unsubscribe freeciv-java
        unsubscribe freeciv-cvs

Pour envoyer un e-mail sur les listes, adressez-le à :

  Pour freeciv, il doit être envoyé à <freeciv@freeciv.org>.
  Pour freeciv-i18n, il doit être envoyé à <freeciv-i18n@freeciv.org>.
  Pour freeciv-dev, il doit être envoyé à <freeciv-dev@freeciv.org>.  
  Pour freeciv-data, il doit être envoyé à <freeciv-data@freeciv.org>.
  Pour freeciv-java, il doit être envoyé à <freeciv-java@freeciv.org>.
  Pour freeciv-ai, il doit être envoyé à <freeciv-ai@freeciv.org>.

En plus de tout ceci, vous pouvez participer à la liste des traducteurs
français de Freeciv à l'adresse suivante :  freeciv-l10n-fr@yahoogroupes.fr 
La chasse aux bogues de traduction et aux mauvaises traductions est ouverte
toute l'année et à tous, et les beta-tests sont rarement désagréables :-)


Internet Relay Chat (IRC)
=========================

Plusieurs joueurs et développeurs sont sur #freeciv sur le réseau freenode.
network. Essayez de vous connecter au serveur :

	irc.freenode.net


Nouvelles versions :
====================

Nous essayons de sortir une nouvelle version de Freeciv environ tous les
quatre mois. Consultez le site web de Freeciv de temps en temps pour voir 
si une version plus récente est sortie !


Et pour conclure :
==================

Amusez-vous bien et envoyez les en enfer !

				   -- L'équipe de Freeciv
